

#include"rfc_amalgamated.h"

class TestGUI : public KFrame , public KButtonListener
{
protected:
	KButton btn1,btn2,btn3;
	KLabel label;
	KCheckBox checkBox;
	KRadioButton radioButton;
	KPushButton pushButton;
	KGroupBox groupBox;
	KProgressBar progressBar;
	KTextBox textBox;
	KPasswordBox passwordBox;
	KTextArea textArea;
	KListBox listBox;
	KComboBox comboBox;
	KTrackBar trackBar;
	KMenuItem menuItem1,menuItem2;
	KMenu fileMenu,subMenu;
	KMenuBar menuBar;

public:
	TestGUI()
	{
		CreateComponent(); // create window before you add components to it...

		SetSize(600,400);

		btn1.SetText(T("Button1"));
		btn1.SetListener(this);
		btn2.SetText(T("Button2"));
		btn2.SetListener(this);
		btn2.SetPosition(0,40);

		label.SetPosition(120,10);

		checkBox.SetCheckedState(true);
		checkBox.SetPosition(120,40);
		
		radioButton.SetCheckedState(true);
		radioButton.SetPosition(230,40);
		
		pushButton.SetPosition(230,0);
		
		groupBox.SetPosition(10,80);
		groupBox.SetSize(100,60);
		
		progressBar.SetPosition(120,90);
		progressBar.SetValue(50);
		
		textBox.SetText(T("text box"));
		textBox.SetPosition(120,120);

		passwordBox.SetText(T("pwd box"));
		passwordBox.SetPosition(230,120);

		textArea.SetText(T("text area"));
		textArea.SetPosition(10,160);

		listBox.AddItem(T("Item1"));
		listBox.AddItem(T("Item2"));
		listBox.AddItem(T("Item3"));
		listBox.AddItem(T("Item4"));
		listBox.SetPosition(230,160);

		comboBox.AddItem(T("Item1"));
		comboBox.AddItem(T("Item2"));
		comboBox.AddItem(T("Item3"));
		comboBox.AddItem(T("Item4"));
		comboBox.SelectItem(1);
		comboBox.SetPosition(230,90);

		trackBar.SetValue(50);
		trackBar.SetPosition(330,90);	

		AddComponent(&btn1);
		AddComponent(&btn2);
		AddComponent(&label);
		AddComponent(&checkBox);
		AddComponent(&radioButton);
		AddComponent(&pushButton);
		AddComponent(&groupBox);
		AddComponent(&progressBar);
		AddComponent(&textBox);
		AddComponent(&passwordBox);
		AddComponent(&textArea);
		AddComponent(&listBox);
		AddComponent(&comboBox);
		AddComponent(&trackBar);

		menuItem1.SetText(T("New..."));
		menuItem2.SetText(T("Open..."));
	
		fileMenu.AddMenuItem(&menuItem1);
		fileMenu.AddMenuItem(&menuItem2);
		fileMenu.AddSeperator();
		fileMenu.AddSubMenu(T("Sub Menu"),&subMenu);

		subMenu.AddMenuItem(&menuItem1);
		
		menuBar.AddMenu(T("File"),&fileMenu);

		menuBar.AddToWindow(this);

	}

	LRESULT OnRClickWindow(WPARAM wParam, LPARAM lParam)
	{
		fileMenu.PopUpMenu(this);
		return 0;
	}


	// handle window messages...
	BEGIN_KMSG_HANDLER
		ON_KMSG(WM_RBUTTONUP,OnRClickWindow) // call OnRClickWindow method when WM_RBUTTONUP msg received
	END_KMSG_HANDLER(KFrame) // KFrame is our parent!


	void OnButtonPress(KButton *button)
	{
		if(button==&btn1)
		{
			MessageBox(compHWND,textArea.GetText(),textBox.GetText(),0);
		}else if(button==&btn2)
		{
			KString fileName;
			if(KCommonDialogBox::ShowOpenFileDialog(this,T("title"),L"Text Files (*.txt)\0*.txt\0",&fileName))
			{
				MessageBox(compHWND,fileName,fileName,0);
			}
		}
	}

	~TestGUI()
	{
	}
};



class MyApp : public KApplication
{
public:
	int Main(KString **argv,int argc)
	{
		
		TestGUI wnd;

		wnd.CenterScreen();
		wnd.SetVisible(true);
		
		DoMessagePump();
		return 0;
	}
};

START_RFC_APPLICATION(MyApp);

